//
// Desencripta un Cookie Lcook de PAPI
// -----------------------------------
// Dos argumentos: Lcook Lkey
//
// Acepta cookies coficados en URL (con caracteres %dd)
//
// Necesita la Lkey del servidor 
//   Definirla en mod_papi, pues sino se la inventa cada vez
//      generarla con
//        cat `find /etc/ -type f -print` | md5sum
//      y configurar
//        PAPILkey  25b42021d604199dd07bd4de8e5c8b16
//
// Compilarlo con:
//   cc -o DesencriptaCookie DesencriptaCookie.c -laprutil-1 -lmcrypt -lcurl

#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
#include <apr-1.0/apr_base64.h>
#include <mcrypt.h>

char* papi_decrypt_AES (char* _input, char* _key)
{
        MCRYPT td;
        int err = -1;
        void *pool;
        
        char *input = malloc (apr_base64_decode_len(_input));
        int length = apr_base64_decode (input, _input);
                
        char *module_name = "rijndael-128";
        if ((td = mcrypt_module_open (module_name, NULL, "ecb", NULL)) == MCRYPT_FAILED) {
          puts ("ERROR:papi_decrypt_AES: MCRYPT_FAILED\n");
          return NULL;
          }

        char *key =strndup ( _key,mcrypt_enc_get_key_size(td) ); 
        // fputs("Key: ",stdout); puts(key);

        int blocksize = mcrypt_enc_get_block_size (td);
        int datasize = (((length-1)/blocksize)+1)*blocksize; 
        // printf("blocksize: %d, datasize %d\n",blocksize,datasize);

        char *blockbuffer = malloc (datasize + 1);
        memcpy (blockbuffer, input, datasize);

        // In ECB, VI is ignored 
        
        if (mcrypt_generic_init (td, key, strlen(key), NULL) != -1) {
          err = mdecrypt_generic (td, blockbuffer, datasize);
          mcrypt_generic_deinit(td);
          }

        mcrypt_module_close (td);

        return blockbuffer;     
}

// Ejemplos:
//   LKEY 25b42021d604199dd07bd4de8e5c8b16 
//
// LCOOK yCmxpMzC7x1Cnl+MusMg4agutAfcZlM2lPICD+wvkxtxsGIGDe/3xN8tWcgboUjYS9jeCweqLNdQIP6R1GSbCA== 
// RESULTADO 1286411429:1286411508:/:consigna:username=hmr@UVAS
//
// LCOOK   pYYF5OKyTHX+CKnHirWl+6gutAfcZlM2lPICD+wvkxtxsGIGDe/3xN8tWcgboUjYS9jeCweqLNdQIP6R1GSbCA==
// RESULTADO   1286411508:1286411508:/:consigna:username=hmr@UVAS 
//
// - este es un cookie codificado en HTML
// LCOOK gW0bOIlI4k58EuLUMYjnUNOOmdH6B16Sy4GAl8MG5dtxsGIGDe%2F3xN8tWcgboUjYS9jeCweqLNdQIP6R1GSbCA%3D%3D
// RESULTADO 1286410891:1286410891:/:consigna:username=hmr@UVAS

int main(int argc, char **argv) {
  char *s;
  char *lcook;
  
  if (argc !=3) { fprintf(stderr,"*** Syntax: DecodeLcook Lcook Lkey\n"); return 99; }
  
  lcook = curl_easy_unescape (NULL, argv[1], 0, NULL);
  s=papi_decrypt_AES(lcook,argv[2]);
  if (s!=NULL) {
    puts(s);
    }
  return 0;
  }



